#include "rawproxy.h"
#include <locale.h>
#include <iconv.h>
#include <langinfo.h>


static iconv_t cd_server;
static iconv_t cd_client;



static void close_conv ( void )
{
if ( cd_server != (iconv_t)(-1) )
    iconv_close ( cd_server );
if ( cd_client != (iconv_t)(-1) )
    iconv_close ( cd_client );
}


void  initTranslation ( void )
{
cd_server = iconv_open ( clientLocale, serverLocale );
cd_client = iconv_open ( serverLocale, clientLocale );
if ( cd_server == (iconv_t)(-1) )
    fprintf ( stderr, "Unable to open %s<-%s\n", clientLocale, serverLocale );
if ( cd_client == (iconv_t)(-1) )
    fprintf ( stderr, "Unable to open %s->%s\n", clientLocale, serverLocale );
atexit ( close_conv );
}


void  setServerLocale ( void )
{
        UCHAR  *serverlocale;
        register UCHAR *pcodepage;

if ( (serverlocale=getenv("LANG")) == NULL )// get LANG environment variable
    serverlocale = "RU_RU";                 // Default is Russian !
if ( (pcodepage=strchr(serverlocale,'.')) != NULL )
    *pcodepage++ = '\0';
setlocale ( LC_ALL, serverlocale );
if ( pcodepage == NULL )
    strcpy(serverLocale, nl_langinfo(CODESET));// setup PC codepage for 
else                                        // name translation
    strcpy(serverLocale, pcodepage );
}


void  setClientLocale ( void )
{
      UCHAR *clientlocale;

if ( (clientlocale=getenv("RAWPROXY_CLIENT_LOCALE")) == NULL )
    clientlocale = "IBM-1251";              // Default is Windows Russian !
strcpy ( clientLocale, clientlocale );      // setup PC codepage for 
                                            // name translation

}



UCHAR *toClient ( UCHAR text[], int len )
{
        unsigned int ilen, olen;
        UCHAR *ibuf, *obuf;
        UCHAR *src;
        UCHAR buf [BUFFER_SIZE+2];

olen = ilen = len;
obuf = (UCHAR *)&buf;
ibuf = (UCHAR *)text;
memcpy ( buf, text, len );
if ( cd_server != (iconv_t)(-1) )
    iconv ( cd_server, &ibuf, &ilen, &obuf, &olen );
memcpy ( text, buf, len );
return ( text );
}


UCHAR *toServer ( UCHAR text[], int len )
{
        unsigned int ilen, olen;
        UCHAR *ibuf, *obuf;
        UCHAR *src;
        UCHAR buf [BUFFER_SIZE+2];

olen = ilen = len;
obuf = (UCHAR *)&buf;
ibuf = (UCHAR *)text;
memcpy ( buf, text, len );
if ( cd_client != (iconv_t)(-1) )
    iconv ( cd_client, &ibuf, &ilen, &obuf, &olen );
memcpy ( text, buf, len );
return ( text );
}
